	TestBlankingFlagsText:
	dc.b	'HBlank/VBlank flags                 '
	TestBlankingFlagsTextEnd:
	TestBlankingFlagsExpectedResult:
	dc.w $0000, $0001, $0000, $0001, $FFFF, $0001, $0000, $0001, $0000, $0001, $0000, $0001
	TestBlankingFlags:
	;Initialize the text result block
	move.w	#(TestBlankingFlagsTextEnd-TestBlankingFlagsText),D7
	move.w	#2,(A0)+ ;Set the number of display lines
	move.w	D7,(A0)+ ;Set the text length
	move.w	#$0018,D6 ;Set the data length
	move.w	D6,(A0)+
	lea		TestBlankingFlagsText,A1
	sub.w	#1,D7
	TestBlankingFlagsWriteText:
	move.b	(A1)+,(A0)+
	dbf	D7,	TestBlankingFlagsWriteText
	move.w	#1,(A0)+ ;Set the expected result data present flag
	lea		TestBlankingFlagsExpectedResult,A1 ;Write the expected result data to the buffer
	sub.w	#1,D6
	TestBlankingFlagsWriteExpectedResultData:
	move.b	(A1)+,(A0)+
	dbf	D6,	TestBlankingFlagsWriteExpectedResultData

	;Check which VBlank flag states are currently being generated
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckVBlankUnset0:
	move.w  $C00004,D5
	btst    #3,D5
	beq TestBlankingFlagsCheckVBlankUnsetFound0
	dbf     D6,TestBlankingFlagsCheckVBlankUnset0
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckVBlankUnsetDone0
	TestBlankingFlagsCheckVBlankUnsetFound0:
	move.w	#$0000,(A0)+
	TestBlankingFlagsCheckVBlankUnsetDone0:
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckVBlankSet0:
	move.w  $C00004,D5
	btst    #3,D5
	bne TestBlankingFlagsCheckVBlankSetFound0
	dbf     D6,TestBlankingFlagsCheckVBlankSet0
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckVBlankSetDone0
	TestBlankingFlagsCheckVBlankSetFound0:
	move.w	#$0001,(A0)+
	TestBlankingFlagsCheckVBlankSetDone0:

	;Check which HBlank flag states are currently being generated
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckHBlankUnset0:
	move.w  $C00004,D5
	btst    #2,D5
	beq TestBlankingFlagsCheckHBlankUnsetFound0
	dbf     D6,TestBlankingFlagsCheckHBlankUnset0
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckHBlankUnsetDone0
	TestBlankingFlagsCheckHBlankUnsetFound0:
	move.w	#$0000,(A0)+
	TestBlankingFlagsCheckHBlankUnsetDone0:
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckHBlankSet0:
	move.w  $C00004,D5
	btst    #2,D5
	bne TestBlankingFlagsCheckHBlankSetFound0
	dbf     D6,TestBlankingFlagsCheckHBlankSet0
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckHBlankSetDone0
	TestBlankingFlagsCheckHBlankSetFound0:
	move.w	#$0001,(A0)+
	TestBlankingFlagsCheckHBlankSetDone0:
	
	;Disable the display
	move.w #$8104,$C00004
	
	;Check which VBlank flag states are currently being generated
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckVBlankUnset1:
	move.w  $C00004,D5
	btst    #3,D5
	beq TestBlankingFlagsCheckVBlankUnsetFound1
	dbf     D6,TestBlankingFlagsCheckVBlankUnset1
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckVBlankUnsetDone1
	TestBlankingFlagsCheckVBlankUnsetFound1:
	move.w	#$0000,(A0)+
	TestBlankingFlagsCheckVBlankUnsetDone1:
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckVBlankSet1:
	move.w  $C00004,D5
	btst    #3,D5
	bne TestBlankingFlagsCheckVBlankSetFound1
	dbf     D6,TestBlankingFlagsCheckVBlankSet1
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckVBlankSetDone1
	TestBlankingFlagsCheckVBlankSetFound1:
	move.w	#$0001,(A0)+
	TestBlankingFlagsCheckVBlankSetDone1:

	;Check which HBlank flag states are currently being generated
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckHBlankUnset1:
	move.w  $C00004,D5
	btst    #2,D5
	beq TestBlankingFlagsCheckHBlankUnsetFound1
	dbf     D6,TestBlankingFlagsCheckHBlankUnset1
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckHBlankUnsetDone1
	TestBlankingFlagsCheckHBlankUnsetFound1:
	move.w	#$0000,(A0)+
	TestBlankingFlagsCheckHBlankUnsetDone1:
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckHBlankSet1:
	move.w  $C00004,D5
	btst    #2,D5
	bne TestBlankingFlagsCheckHBlankSetFound1
	dbf     D6,TestBlankingFlagsCheckHBlankSet1
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckHBlankSetDone1
	TestBlankingFlagsCheckHBlankSetFound1:
	move.w	#$0001,(A0)+
	TestBlankingFlagsCheckHBlankSetDone1:

	;Re-enable the display
	move.w #$8144,$C00004

	;Check which VBlank flag states are currently being generated
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckVBlankUnset2:
	move.w  $C00004,D5
	btst    #3,D5
	beq TestBlankingFlagsCheckVBlankUnsetFound2
	dbf     D6,TestBlankingFlagsCheckVBlankUnset2
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckVBlankUnsetDone2
	TestBlankingFlagsCheckVBlankUnsetFound2:
	move.w	#$0000,(A0)+
	TestBlankingFlagsCheckVBlankUnsetDone2:
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckVBlankSet2:
	move.w  $C00004,D5
	btst    #3,D5
	bne TestBlankingFlagsCheckVBlankSetFound2
	dbf     D6,TestBlankingFlagsCheckVBlankSet2
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckVBlankSetDone2
	TestBlankingFlagsCheckVBlankSetFound2:
	move.w	#$0001,(A0)+
	TestBlankingFlagsCheckVBlankSetDone2:

	;Check which HBlank flag states are currently being generated
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckHBlankUnset2:
	move.w  $C00004,D5
	btst    #2,D5
	beq TestBlankingFlagsCheckHBlankUnsetFound2
	dbf     D6,TestBlankingFlagsCheckHBlankUnset2
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckHBlankUnsetDone2
	TestBlankingFlagsCheckHBlankUnsetFound2:
	move.w	#$0000,(A0)+
	TestBlankingFlagsCheckHBlankUnsetDone2:
	move.w	#$7FFF,D6
	TestBlankingFlagsCheckHBlankSet2:
	move.w  $C00004,D5
	btst    #2,D5
	bne TestBlankingFlagsCheckHBlankSetFound2
	dbf     D6,TestBlankingFlagsCheckHBlankSet2
	move.w	#$FFFF,(A0)+
	bra TestBlankingFlagsCheckHBlankSetDone2
	TestBlankingFlagsCheckHBlankSetFound2:
	move.w	#$0001,(A0)+
	TestBlankingFlagsCheckHBlankSetDone2:

	rts
